#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h> 
#include "fxlib.h"
#include "mylib.h"

//beforeRefresh is an example callback function
void callbackEvents(void* ptr)
{
  double w,h,area;
  struct Dialog* dlg;
  struct DialogItem* item;
  struct String* s;
  dlg=(struct Dialog*)ptr;// cast ptr to dlg. 
  if(dlg->eventType==EVENT_BEFORE_REFRESH)
  {
    s=stringInit("",32);
    item=dialogGet(dlg,2);//first edit box
    w=atof(item->text->data);//w now holds the width
    item=dialogGet(dlg,4);//second edit box
    h=atof(item->text->data);//h now hold the height
    area=w*h;
    stringSprintf(s,"Area is:%f",area);
    item=dialogGet(dlg,6);//the third label
    stringSet(item->text,s->data);//sets the label text
    stringFree(s);//frees temp string s
  };
}

//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
   unsigned int key;
   int ret,w1,w2,w3,w4,w5;
   double d1,d2,d3;
   struct String* s1;
   struct String* s2;
   struct String* s3;
   struct StringList* sl;
   struct StringListNode* slnode;
   char* bufp;
   struct Dialog* dlg;
   struct DialogItem* item;
   
   //a simple message box
   messageBox("Welcome to mylib tester app!|This is a second line|This is a third line","title Welcome");
   //string Manipulation functions
   messageBox("String manipulation functions","Message1");
   s1=stringInit("ABC__3.14159_",1);//initialize s1
   s2=stringInit("",5);//initialize empty s2 with malloc size 5
   s3=stringInit("",1);//init empty s3 with size 1
   Bdisp_AllClr_DDVRAM();
   PrintMini(1,1,(unsigned char*)stringGet(s1),MINI_OVER);//print s1
   PrintMini(1,1,(unsigned char*)s1->data,MINI_OVER);//same with above line
   stringSet(s2,"testString2");//sets s2
   PrintMini(1,8,(unsigned char*)s2->data,MINI_OVER);//print s2
   stringAppend(s2,"word");//s2 is now "testString2word"
   PrintMini(1,16,(unsigned char*)s2->data,MINI_OVER);//print s2
   w1=stringLength(s2);//w1 now holds length of s2 (15)
   stringSetInteger(s2,w1,"%d");//s2 now holds "15"
   PrintMini(1,24,(unsigned char*)s2->data,MINI_OVER);//print s2
   stringSetDouble(s2,3.14159,"%.3f");//s2 now holds "3.142"
   PrintMini(1,32,(unsigned char*)s2->data,MINI_OVER);//print s2
   stringFormatValue(s3,"%.1f",s2->data);//s3 is now "3.1"
   PrintMini(1,40,(unsigned char*)s3->data,MINI_OVER);//print s3
   w1=1;d1=6.890;
   stringSprintf(s3,"%d %.3f",w1,d1);//line normal sprintf s3 is now "1 6.890"
   PrintMini(1,48,(unsigned char*)s3->data,MINI_OVER);//print s3
   stringFill(s2,'a',4);// s2 is filled with "aaaa"
   PrintMini(1,56,(unsigned char*)s2->data,MINI_OVER);//print s2
   GetKey(&key);
   Bdisp_AllClr_DDVRAM();
   stringRemoveAt(s1,4,2);//remove the 2 chars of s1 starting from index 4 . s1 is now "ABC3.14159_"
   PrintMini(1,1,(unsigned char*)s1->data,MINI_OVER);//print s1
   stringMid(s1,4,7,s2);//gets the 7 chars of s1 starting from 4, and store the result to s2. s2 is now "3.14159"
   PrintMini(1,8,(unsigned char*)s2->data,MINI_OVER);//print s2
   stringSet(s1,"a,b,1,c,2,d,3");//sets s1
   w1=stringIdx(s1,',',1);//gets the position of first ',' in s1. w1 is now 2
   stringSetInteger(s2,w1,"%d");//s2 is now "2"
   PrintMini(1,16,(unsigned char*)s2->data,MINI_OVER);//print s2
   w1=stringListCount(s1,',');//count the number of items in s1 separated with ','. w1 is now 7
   stringSetInteger(s2,w1,"%d");//s2 is now "2"
   PrintMini(1,16,(unsigned char*)s2->data,MINI_OVER);//print s2
   stringListItem(s1,',',4,s2);//s2 now holds the 4th item in s1 separated with ','. s2 is now "c"
   PrintMini(1,24,(unsigned char*)s2->data,MINI_OVER);//print s2
   stringListItemModify(s1,',',4,"ccc",s2);//modify the 4th item in s1 with ccc. s2 is now "a,b,1,ccc,2,d,3"
   PrintMini(1,32,(unsigned char*)s2->data,MINI_OVER);//print s2
   stringListItemModify(s1,',',4,"",s2);//modify the 4th item in s1 with "". s2 is now "a,b,1,,2,d,3"
   PrintMini(1,40,(unsigned char*)s2->data,MINI_OVER);//print s2
   //done with the s3, so free the memory and keep s1,s2 for further use
   stringFree(s3);
   GetKey(&key);
   messageBox("string test done!","message2");
   
   messageBox("input box test","input");
   Bdisp_AllClr_DDVRAM();
   stringInput(2,3,s1,8,20,"edit me",1,INPUT_STRING);//input s1 from user, with initial value "edit me" at screen position 2,3 with maximum editor box size 8 chars, and maximum string size 20chars
   stringSprintf(s2,"you entered:%s",s1->data);//s2 now holds the text "you entered:your data"
   PrintMini(1,32,(unsigned char*)s2->data,MINI_OVER);//print s2
   GetKey(&key);
   
   Bdisp_AllClr_DDVRAM();
   messageBox("let's make a stringList","slist");
   sl=slistInit(0,32);//initialize sl with 0 elements and 32 chars for each string
   slistSetAll(sl,',',"a,b,c,d");//sets the sl to hold the values separated by ','
   //now walk through the items
   w1=1;
   slnode=slistFirst(sl);
   while(slnode!=0)
   {
     stringSet(s1,slnode->data);//s1 now holds a,b,c,d in the loop
     PrintMini(1,(w1-1)*8,(unsigned char*)s1->data,MINI_OVER);//print item1
     PrintMini(16,(w1-1)*8,(unsigned char*)slnode->data,MINI_OVER);//same as above line
     slnode=slistNext(sl);
     w1++;
   };
   GetKey(&key);
   Bdisp_AllClr_DDVRAM();
   // now index walk the same items;
   for(w1=1;w1<=sl->count;w1++)
   {
     bufp=slistGet(sl,w1);//bufp now points to the w1 item
     PrintMini(1,(w1-1)*8,(unsigned char*)bufp,MINI_OVER);//print item
   };
   slistSet(sl,2,"B");//sets the 2nd element of sl to be "B". sl is now a,B,c,d
   slistGetAll(sl,'&',s1);//gets all the elements of the list separated with '&'. s1 is now "a&B&c&d"
   PrintMini(1,40,(unsigned char*)s1->data,MINI_OVER);
   slistAppend(sl,"e");//append e in sl
   slistPrepend(sl,"0");//prepend 0 in sl
   //sl is now 0,a,B,c,d,e
   slistGetAll(sl,'|',s1);//gets all the elements of the list separated with '&'. s1 is now "0|a|B|c|d|e"
   PrintMini(1,48,(unsigned char*)s1->data,MINI_OVER);
   slistRemoveAt(sl,2);//removes 2nd item (a) from the list
   slistGetAll(sl,'&',s1);//gets all the elements of the list separated with '&'. s1 is now "0|B|c|d|e"
   PrintMini(1,56,(unsigned char*)s1->data,MINI_OVER);
   GetKey(&key);
   w1=multipleChoiceBox(sl,1);//show a multiplechoice box of sl
   stringSprintf(s1,"you chose %d item1",w1);
   messageBox(s1->data,"chosen");
   slistFree(sl);//frees sl memory
   
   messageBox("now a question box comes","title");
   w1=questionBox("Are you?",1);//w1 holds 1 if it is yes 0 if it is no
   
   messageBox("now a menu execs","menu");
   Bdisp_AllClr_DDVRAM();
   w1=execMenu("Alph|Abc|Def|Ghi|ijklmno,Numb|one|two|three,Text|text1|text2,,,Done");
   //menu holds 6 main menu buttons separated with ',' each menu button can have popupsubmenus separated with '|'
   //execMenu returns 100-600 for 1-6 main menu choices. and 1-6 for submenu choices.
   //for example if you choose Def from Alph menu you will get 102
   stringSprintf(s1,"menu choice:%d",w1);
   messageBox(s1->data,"menu2");
   
   messageBox("last a dialog will show","show1");
   dlg=dialogInit();//inits the dialog
   item=dialogItemInit();//inits an item dialog
   dialogItemSetLabel(item,1,8,"width:");dialogAppend(dlg,item);//sets item to be a label and appends it to dlg
   dialogItemSetEditBox(item,40,8,45,9,"1.000","%.2f");dialogAppend(dlg,item);//sets item to be an editbox, with pos 40,8 size 45,9 initial value "1.000" format "%.2f" and appends it to dlg
   dialogItemSetLabel(item,1,18,"height:");dialogAppend(dlg,item);//sets item to be a label and appends it to dlg
   dialogItemSetEditBox(item,40,18,45,9,"1.000","%.2f");dialogAppend(dlg,item);//sets item to be an editbox, with pos 40,18 size 45,9 initial value "1.000" format "%.2f" and appends it to dlg
   dialogItemSetButton(item,30,40,30,10,"CalcB");dialogAppend(dlg,item);//sets item to be a button with pos 30,40 and size 30,10 with label "CalcB"
   dialogItemSetMenu(item,"Calc,,,,,");dialogAppend(dlg,item);//sets item to be a menu with only choice "Calc"
   dialogItemFree(item);//frees temp item
   dialogExec(dlg,"Rectangular Area",1);//executes the dialog
   //dlg->retCode returns 5 if button is pressed (5th item in dialog) and 100 if menu is used
   //dlg->retSubcode returns menu choice or 0 if menu is not used
   if(dlg->retCode==5){//button pressed
     item=dialogGet(dlg,2);//first edit box
     d1=atof(item->text->data);//d1 now holds the width
     item=dialogGet(dlg,4);//second edit box
     d2=atof(item->text->data);//d2 now hold the height
     stringSprintf(s1,"the area is:%f",d1*d2);
     messageBox(s1->data,"button pressed");
   };
   if(dlg->retCode==100){//1st menu choice
     item=dialogGet(dlg,2);//first edit box
     d1=atof(item->text->data);//d1 now holds the width
     item=dialogGet(dlg,4);//second edit box
     d2=atof(item->text->data);//d2 now hold the height
     stringSprintf(s1,"the area is:%f",d1*d2);
     messageBox(s1->data,"menu chosen");
   };
   
   Bdisp_AllClr_DDVRAM();
   messageBox("the same dialog with callbacks","dlg2");
   dialogRemoveAt(dlg,5);//removes button
   item=dialogItemInit();
   dialogItemSetLabel(item,1,40,"");dialogAppend(dlg,item);//we add a third label at pos 1,40
   //6th item of dialog is now this label
   dialogItemFree(item);
   dlg->event=callbackEvents;//sets the callback function defined at the start of file
   dialogExec(dlg,"Rectangular Area",1);//executes the dialog
   if(dlg->retCode=100){//we have only one menu choice 
	//do something here
     item=dialogGet(dlg,6);//the third label
     messageBox(item->text->data,"the area");
   };
   dialogFree(dlg);//done with dialog free memory
   stringFree(s1);
   stringFree(s2);
   
   return 0;
}




#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

